'*************************************************************
'                Subdir Sizes Script
'*************************************************************
'***** This script will go through all he subdirs       ******
'***** in any directory and will return a log file      ******
'***** listing all the subdir sizes.                    ******
'*****                                                  ******
'***** How to use:  simply drop in any directory and    ******
'***** double click.  Can slso be run via command line  ******
'***** but will return the subdir sizes of the dir that ******
'***** contains the script. will create file called     ******
'***** SubDirectorySizesMMDDYY.htm in current dir.      ******
'*****                                                  ******
'***** Written: 11/05/2006                              ******
'***** Author: Robert "Dude" Spellings Jr.              ******
'***** http://www.spellingsconsulting.com               ******
'*************************************************************
'*************************************************************

' set date var
vDate = now()

' set date var for use in filenames
vMonth = DatePart("m", vDate)
vDay = DatePart("d", vDate)
vYear = DatePart("yyyy", vDate)
' add preceding zero for filename consistency
if vDay < 10 then 
	vDay = "0" & vDay
end if 	
if vMonth < 10 then 
	vMonth = "0" & vMonth
end if
strDate = vMonth & vDay & vYear

' create objects
Set cNetCommands = CreateObject("WScript.Network")
Set cFSCommands = CreateObject("Scripting.FileSystemObject")
Set cShellCommands = CreateObject("WScript.Shell")


' get path of this script
path = cFSCommands.GetAbsolutePathName(".")
' set target directory (current dir) based on path
Set vDir = cFSCommands.GetFolder(path) 

'create object for log file  
set oLogFile = cFSCommands.CreateTextFile(vDir&"\SubDirectorySizes"&strDate&".htm", True)
' start writing log file
oLogFile.WriteLine("<html><head><title>Subdir Sizes for " & vDir & "</title></head><body><table border='0' width='100%'>")
' write date to log file
oLogFile.WriteLine("<tr><td colspan='2'>Log File for subdir_sizes.vbs.  Script Start Time: " & vDate & ".</td></tr>") 
' write target dir to log file
oLogFile.WriteLine("<tr><td colspan='2'>Target Directory: " & vDir & "</td></tr>")
' write line of path to logfile
oLogFile.WriteLine("<tr><td colspan='2'>Path of This Log File: " & vDir & "\SubDirectorySizes"&strDate&".htm </td></tr>")
' write spacer line
oLogFile.WriteLine("<tr><td colspan='2'>*****************************************************************</td></tr>") 

' set oFolderP object to vDir var defined at top of script
Set oFolderP = cFSCommands.GetFolder(vDir)

' set var for total folder size
vTotSize = 0
' create counter to alternate row colors
nCounter = 0
' start loop through subdirs of VdIR - (loop 1)
For Each objSubFolder in oFolderP.SubFolders
' use nCounter to determine Row Color
vRowMod = nCounter mod 2
if vRowMod = 0 then
	vRowColor = "#FFFFFF"
else
	vRowColor = "#EEEEEE"
end if 
' get folder size, returned in bytes (not KB or MB)
vSize = objSubFolder.size
' divide by 1048576 bytes to get MB
vSize = FormatNumber(vSize/1048576, 2)
' if larger than 1024MB, convert to GB.  else, add "MB"
if vSize >= 1024 then
	vcSize = FormatNumber(vSize/1024, 2) & "GB**"  'add astrick to distinguish between MB and GB on log.
else
	vcSize = vSize & "MB"
end if 
' write folder name and size to log file
oLogFile.WriteLine("<tr><td bgcolor='" & vRowColor & "'>" & objSubFolder & "</td><td bgcolor='" & vRowColor & "'>" & vcSize & "</td></tr>")
' add folder size to total
vTotSize = vTotSize + vSize
' increment counter
nCounter = nCounter + 1
Next
' calculate GB or MB for vTotSize
if vTotSize >= 1024 then
	vcTotSize = FormatNumber(vTotSize/1024, 2) & "GB**"  'add astrick to distinguish between MB and GB on log.
else
	vcTotSize = vTotSize & "MB"
end if 

oLogFile.WriteLine("<tr><td colspan='2'>*****************************************************************</td></tr>") 
oLogFile.WriteLine("<tr><td>Total Space being used in " & vDir & ": </td><td>" & vcTotSize & "</td></tr>") 
oLogFile.WriteLine("</table></body></html>")

' automatically open the log file in notepad when script completes
Set WshShell = WScript.CreateObject("WScript.Shell")
Return = WshShell.Run("iexplore " & vDir&"\SubDirectorySizes"&strDate&".htm", 10, true)
Set WshShell = nothing